//+------------------------------------------------------------------+
//|                                   nn_weights_with_the_tester.mq5 |
//|                                                Lorentzos Roussos |
//|                              https://www.mql5.com/en/users/lorio |
//+------------------------------------------------------------------+
#property copyright "Lorentzos Roussos"
#property link      "https://www.mql5.com/en/users/lorio"
#property version   "1.00"
enum activation_f{
activation_sigmoid=0,//sigmoid
activation_tanh=1,//tanh
activation_relu=2//relu
};
input activation_f ACTIVATION_MODE=activation_relu;//activation mode : 
input int sl=200;//StopLoss
input int tp=500;//TakeProfit
input string note1="";//Layer1 Node1 weights with input layer
input double L1N1W1=1.0;//L1N1W1
input double L1N1W2=1.0;//L1N1W2
input double L1N1W3=1.0;//L1N1W3
input double L1N1W4=1.0;//L1N1W4
input double L1N1W5=1.0;//L1N1W5
input double L1N1W6=1.0;//L1N1W6
input string note2="";//Layer1 Node2 weights with input layer
input double L1N2W1=1.0;//L1N2W1
input double L1N2W2=1.0;//L1N2W2
input double L1N2W3=1.0;//L1N2W3
input double L1N2W4=1.0;//L1N2W4
input double L1N2W5=1.0;//L1N2W5
input double L1N2W6=1.0;//L1N2W6
//i did not think this through did i
input string note3="";//Layer1 Node3 weights with input layer
input double L1N3W1=1.0;//L1N3W1
input double L1N3W2=1.0;//L1N3W2
input double L1N3W3=1.0;//L1N3W3
input double L1N3W4=1.0;//L1N3W4
input double L1N3W5=1.0;//L1N3W5
input double L1N3W6=1.0;//L1N3W6
input string note4="";//Layer1 Node4 weights with input layer
input double L1N4W1=1.0;//L1N4W1
input double L1N4W2=1.0;//L1N4W2
input double L1N4W3=1.0;//L1N4W3
input double L1N4W4=1.0;//L1N4W4
input double L1N4W5=1.0;//L1N4W5
input double L1N4W6=1.0;//L1N4W6
input string note5="";//Layer2 Node1 weights with Layer1
input double L2N1W1=1.0;//L2N1W1
input double L2N1W2=1.0;//L2N1W2
input double L2N1W3=1.0;//L2N1W3
input double L2N1W4=1.0;//L2N1W4
input string note6="";//Layer2 Node2 weights with Layer1
input double L2N2W1=1.0;//L2N2W1
input double L2N2W2=1.0;//L2N2W2
input double L2N2W3=1.0;//L2N2W3
input double L2N2W4=1.0;//L2N2W4
input string note7="";//Layer2 Node3 weights with Layer1
input double L2N3W1=1.0;//L2N3W1
input double L2N3W2=1.0;//L2N3W2
input double L2N3W3=1.0;//L2N3W3
input double L2N3W4=1.0;//L2N3W4
input string note8="";//Layer2 Node4 weights with Layer1
input double L2N4W1=1.0;//L2N4W1
input double L2N4W2=1.0;//L2N4W2
input double L2N4W3=1.0;//L2N4W3
input double L2N4W4=1.0;//L2N4W4
input string note9="";//Layer3 Node1 weights with Layer1
input double L3N1W1=1.0;//L3N1W1
input double L3N1W2=1.0;//L3N1W2
input double L3N1W3=1.0;//L3N1W3
input double L3N1W4=1.0;//L3N1W4
//first a custom signal + trade
//a signal
class mySignal{
bool     live,traded;
char     direction;//0 none -1 sell 1 buy
datetime openTime;
double openPrice,slPrice,tpPrice,PL;
       public:
       mySignal(void){reset();}
      ~mySignal(void){reset();}
  void reset(){
       live=false;
       direction=0;
       openTime=0;
       openPrice=0.0;
       slPrice=0.0;
       tpPrice=0.0;
       PL=0.0;
       }
  void start(char _direction,double _bid,double _ask,datetime _time,int _sl,int _tp,bool is_traded){
       direction=_direction;
       openTime=_time;
       traded=is_traded;
       if(direction==-1)
         {
         openPrice=_bid;
         slPrice=_ask+((double)_sl)*_Point;
         tpPrice=_bid-((double)_tp)*_Point;
         }
       else
         {
         openPrice=_ask;
         slPrice=_bid-((double)_sl)*_Point;
         tpPrice=_ask+((double)_tp)*_Point;         
         }
       PL=(_ask-_bid)/_Point;
       live=true;
       }
double profit(){return(PL);}
  bool was_traded(){return(traded);}
  bool active(){return(live);}
       //returns true if it closed 
  bool manage(double _ask,double _bid){
       if(direction==1){
       PL=(_bid-openPrice)/_Point;
       if(_bid<=slPrice||_bid>=tpPrice){
         live=false;
         return(true);
         }
       }else{
       PL=(openPrice-_ask)/_Point;
       if(_ask>=slPrice||_ask<=tpPrice){
         live=false;
         return(true);
         }
       }
       return(false);
       } 
  
};
//live signals 
mySignal LIVE[];
int LIVE_TOTAL=0,LIVE_STEP=10000;

int add_signal(char _direction,double _bid,double _ask,datetime _time,int _sl,int _tp,bool is_traded){
    LIVE_TOTAL++;
    if(LIVE_TOTAL>ArraySize(LIVE)){ArrayResize(LIVE,LIVE_TOTAL+LIVE_STEP,0);}
    LIVE[LIVE_TOTAL-1].start(_direction,_bid,_ask,_time,_sl,_tp,is_traded);
    return(LIVE_TOTAL-1);
    }
//and some stats in points
  double max_drawup=0,max_drawdown=0,equity=0,balance=0;    
//now we need a strategy let's do the silliest thing possible
//we'll check the delta of the latest close price with the candle at distance x and increase the distance as we go
//for 20 steps , so the first layer will be 20 nodes , theoretically 
//we'll also need to provide a unit for measurement , that will be the the atr at the close 
//or we could normalize all the values 
//so , let's build that function it pulls the steps and the x step and fills an array with features
bool fill_features(int x_step,int x_step_increase,int steps,double &results[]){
//first is the data available , this function is called only live or in the tester 
  int barz=iBars(_Symbol,_Period);
  double range_sum=0.0;
  int nav=1;
  double nowclose=iClose(_Symbol,_Period,nav);
  for(int i=0;i<steps;i++)
     {
     nav+=x_step;
     x_step+=x_step_increase;
     //if we fall off the cliff , false 
       if(nav>=barz){return(false);}
     results[i]=nowclose-iClose(_Symbol,_Period,nav);
     range_sum+=iHigh(_Symbol,_Period,nav)-iLow(_Symbol,_Period,nav);
     }
  range_sum/=((double)steps);
  for(int i=0;i<steps;i++){results[i]/=range_sum;}
return(true);
}
//need nodes , damn

class node_layer;
class node{
double       activation_value,value_coming_in_to_activation;
double       inbound_weights[];//weights to the next layer
activation_f activation_function;
             //
             public:
             node(void){reset();}
            ~node(void){reset();}
        void reset(){activation_value=0.0;value_coming_in_to_activation=0.0;activation_function=activation_sigmoid;ArrayFree(inbound_weights);}
        void setup(activation_f _activation_mode){activation_function=_activation_mode;} 
        void setup_inbound_weights(double &w[]){
             ArrayResize(inbound_weights,ArraySize(w),0);
             ArrayCopy(inbound_weights,w,0,0,ArraySize(w));
             }
        void set_value(double value){activation_value=value;value_coming_in_to_activation=value;}
        void calculate_value_coming_in_to_activation(node_layer &previous_layer){
             double sum=0.0;
             for(int i=0;i<ArraySize(inbound_weights);i++){
                sum+=inbound_weights[i]*previous_layer.get_node_value(i);
                }
             value_coming_in_to_activation=sum;
             }
        void activate(){
                  if(activation_function==activation_relu){activation_value=MathMax(0,value_coming_in_to_activation);}
             else if(activation_function==activation_tanh){activation_value=MathTanh(value_coming_in_to_activation);}
             else if(activation_function==activation_sigmoid){activation_value=1/(1+MathPow(2.718,-value_coming_in_to_activation));}
             }
      double get_activation_value(){return(activation_value);}
      double get_value_coming_in_the_activation(){return(value_coming_in_to_activation);}
        
};
//we also need layers ...ffff
class node_layer{
node nodes[];
     public:
     node_layer(void){reset();}
    ~node_layer(void){reset();}
void reset(){ArrayFree(nodes);}
void add_and_fill_node_values(double &values[]){
     for(int i=0;i<ArraySize(values);i++){
        int ix=add_node();
        nodes[ix].set_value(values[i]);
        }
     }
void fill_nodes(double &values[]){for(int i=0;i<ArraySize(values);i++){nodes[i].set_value(values[i]);}}
void add_node_with_inbound_weights(activation_f activation_function,double &w[]){
     int ix=add_node();
     nodes[ix].setup(activation_function);
     nodes[ix].setup_inbound_weights(w);
     }     
void add_nodes(int total){ArrayResize(nodes,total,0);}
 int add_node(){int ns=ArraySize(nodes)+1;ArrayResize(nodes,ns,0);return(ns-1);}
void calculate_values(node_layer &previous_layer){
     for(int i=0;i<ArraySize(nodes);i++)
        {
        nodes[i].calculate_value_coming_in_to_activation(previous_layer);
        nodes[i].activate();
        }    
     }
double get_node_value(int ix){return(nodes[ix].get_activation_value());}
};
//and a network 
class network{
node_layer layers[];
      public:
      network(void){reset();}
     ~network(void){reset();}
 void reset(){ArrayFree(layers);}
node_layer* add_layer(){int ns=ArraySize(layers)+1;ArrayResize(layers,ns,0);return(GetPointer(layers[ns-1]));}
 void feed_forward(double &inputs[]){
      //change first layer 
        layers[0].fill_nodes(inputs);
      //loop to other layers 
        for(int i=1;i<ArraySize(layers);i++)
           {
           layers[i].calculate_values(layers[i-1]);
           }
      }
double get_output(){
       return(layers[ArraySize(layers)-1].get_node_value(0));
       }
};
//okay so scrap the 20 steps , i'll do 6 , 6 input nodes , linking to 4 , linking to 4 linking to 1 
//6 x 4 + 4 x 4 + 4 44 weights , 44 inputs to optimize hmm i see the inconvenience
//anyway
//network
network NET; 
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
datetime barstamp=0;
bool SystemBusy=false;
double FEATURES[];
int OnInit()
  {
//---
  ArrayResize(FEATURES,6,0);
  equity=0.0;
  balance=0.0;
  max_drawdown=0.0;
  max_drawup=0.0;
  node_layer* editor;
  NET.reset();
  //input layer , signal input not user input
  editor=NET.add_layer();
  editor.add_nodes(6);
  //first hidden 4
  double L1N1weights[]={L1N1W1,L1N1W2,L1N1W3,L1N1W4,L1N1W5,L1N1W6};
  double L1N2weights[]={L1N2W1,L1N2W2,L1N2W3,L1N2W4,L1N2W5,L1N2W6};
  double L1N3weights[]={L1N3W1,L1N3W2,L1N3W3,L1N3W4,L1N3W5,L1N3W6};
  double L1N4weights[]={L1N4W1,L1N4W2,L1N4W3,L1N4W4,L1N4W5,L1N4W6};
  //this is getting annoying
  editor=NET.add_layer();
  editor.add_node_with_inbound_weights(ACTIVATION_MODE,L1N1weights);
  editor.add_node_with_inbound_weights(ACTIVATION_MODE,L1N2weights);
  editor.add_node_with_inbound_weights(ACTIVATION_MODE,L1N3weights);
  editor.add_node_with_inbound_weights(ACTIVATION_MODE,L1N4weights);
  //layer 2 
  double L2N1weights[]={L2N1W1,L2N1W2,L2N1W3,L2N1W4};
  double L2N2weights[]={L2N2W1,L2N2W2,L2N2W3,L2N2W4};
  double L2N3weights[]={L2N3W1,L2N3W2,L2N3W3,L2N3W4};
  double L2N4weights[]={L2N4W1,L2N4W2,L2N4W3,L2N4W4};
  editor=NET.add_layer();
  editor.add_node_with_inbound_weights(ACTIVATION_MODE,L2N1weights);
  editor.add_node_with_inbound_weights(ACTIVATION_MODE,L2N2weights);
  editor.add_node_with_inbound_weights(ACTIVATION_MODE,L2N3weights);
  editor.add_node_with_inbound_weights(ACTIVATION_MODE,L2N4weights);
  //output yay
  double L3N1weights[]={L3N1W1,L3N1W2,L3N1W3,L3N1W4};
  editor=NET.add_layer();
  editor.add_node_with_inbound_weights(ACTIVATION_MODE,L3N1weights);  
  barstamp=0;
  ArrayFree(LIVE);
  LIVE_TOTAL=0;
  SystemBusy=false;
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
  if(!SystemBusy)
  {
  SystemBusy=true;
  
  double Bid=(double)SymbolInfoDouble(_Symbol,SYMBOL_BID);
  double Ask=(double)SymbolInfoDouble(_Symbol,SYMBOL_ASK);
  if(Bid>0.0&&Ask>0.0)
  { 
  //manage signals
    int from=LIVE_TOTAL-1; 
    bool closed=false;
    double equity_now=0.0;
    for(int i=from;i>=0;i--)
    {
    if(LIVE[i].active())
    {
    equity_now+=LIVE[i].profit();
    bool remove_it=LIVE[i].manage(Ask,Bid);
    //removal 
      if(remove_it){
      balance+=LIVE[i].profit();
      equity_now-=LIVE[i].profit();
      LIVE[i]=LIVE[LIVE_TOTAL-1];
      LIVE_TOTAL--;
      closed=true;
      }
    }
    }
    equity_now+=balance;
    equity=equity_now;
    if(equity>max_drawup){max_drawup=equity;}
    if(equity<max_drawdown){max_drawdown=equity;}
  //---------------------------------------
  datetime time=iTime(_Symbol,_Period,0);
  if(time>barstamp)
    {
    barstamp=time;
    //i'll just do the buying side , so it will "learn" or "memorize" buying
      //actually we'll try to hit correct buying by chance with the tester 
        //so we get the signal from the network , so calculate the input values 
          //sco

            if(fill_features(1,4,6,FEATURES)){
            //plunge them into the input layer 
              NET.feed_forward(FEATURES);
              bool buy=false;
            //if activation function is sigmoid
              if(ACTIVATION_MODE==activation_sigmoid){
              //>0.5
                if(NET.get_output()>0.5){buy=true;}
              }
              else if(ACTIVATION_MODE==activation_relu){
              //>0
                if(NET.get_output()>0){buy=true;}
              }
              else if(ACTIVATION_MODE==activation_tanh){
              //>0
                if(NET.get_output()>0){buy=true;}
              }
            //buy 
              if(buy)
                {
                add_signal(1,Bid,Ask,time,sl,tp,true);
                }
            }
    }
  }
  
  SystemBusy=false;
  } 
  }
//+------------------------------------------------------------------+
//| Tester function                                                  |
//+------------------------------------------------------------------+
double OnTester()
  {
//---
   double ret=equity;
//---

//---
   return(ret);
  }
//+------------------------------------------------------------------+
//| TesterInit function                                              |
//+------------------------------------------------------------------+
void OnTesterInit()
  {
//---
   
  }
//+------------------------------------------------------------------+
//| TesterPass function                                              |
//+------------------------------------------------------------------+
void OnTesterPass()
  {
//---
   
  }
//+------------------------------------------------------------------+
//| TesterDeinit function                                            |
//+------------------------------------------------------------------+
void OnTesterDeinit()
  {
//---
   
  }
//+------------------------------------------------------------------+
